﻿using Luski.net.JsonTypes.BaseTypes;
using System.Text.Json.Serialization;

namespace Luski.net.JsonTypes.HTTP;

internal class Channel : HTTPRequest
{
    [JsonPropertyName("id")]
    [JsonInclude]
    public long Id { get; set; } = default!;
}

[JsonSerializable(typeof(Channel))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.CamelCase,
    WriteIndented = false)]
internal partial class ChannelContext : JsonSerializerContext
{

}
