﻿using System.Text.Json.Serialization;
using Luski.net.Enums;
using Luski.net.JsonTypes.BaseTypes;

namespace Luski.net.JsonTypes.HTTP;

internal class Status : HTTPRequest
{
    [JsonPropertyName("status")]
    [JsonInclude]
    public UserStatus UserStatus { get; set; } = default!;
}

[JsonSerializable(typeof(Status))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.CamelCase,
    WriteIndented = false)]
internal partial class StatusContext : JsonSerializerContext
{

}
